## qr-code-generator 1.4.0

=== cpp/Makefile ===
# 
# Makefile for QR Code generator (C++)
# 
# Copyright (c) Project Nayuki. (MIT License)
# https://www.nayuki.io/page/qr-code-generator-library
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# - The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
# - The Software is provided "as is", without warranty of any kind, express or
#   implied, including but not limited to the warranties of merchantability,
#   fitness for a particular purpose and noninfringement. In no event shall the
#   authors or copyright holders be liable for any claim, damages or other
#   liability, whether in an action of contract, tort or otherwise, arising from,
#   out of or in connection with the Software or the use or other dealings in the
#   Software.
# 


# ---- Configuration options ----

# External/implicit variables:
# - CXX: The C++ compiler, such as g++ or clang++.
# - CXXFLAGS: Any extra user-specified compiler flags (can be blank).

# Mandatory compiler flags
CXXFLAGS += -std=c++11
# Diagnostics. Adding '-fsanitize=address' is helpful for most versions of Clang and newer versions of GCC.
CXXFLAGS += -Wall -fsanitize=undefined
# Optimization level
CXXFLAGS += -O1


# ---- Controlling make ----

# Clear default suffix rules
.SUFFIXES:

# Don't delete object files
.SECONDARY:

# Stuff concerning goals
.DEFAULT_GOAL = all
.PHONY: all clean


# ---- Targets to build ----

LIB = qrcodegen
LIBFILE = lib$(LIB).a
LIBOBJ = BitBuffer.o QrCode.o QrSegment.o
MAINS = QrCodeGeneratorDemo QrCodeGeneratorWorker

# Build all binaries
all: $(LIBFILE) $(MAINS)

# Delete build output
clean:
	rm -f -- $(LIBOBJ) $(LIBFILE) $(MAINS:=.o) $(MAINS)
	rm -rf .deps

# Executable files
%: %.o $(LIBFILE)
	$(CXX) $(CXXFLAGS) -o $@ $< -L . -l $(LIB)

# The library
$(LIBFILE): $(LIBOBJ)
	$(AR) -crs $@ -- $^

# Object files
%.o: %.cpp .deps/timestamp
	$(CXX) $(CXXFLAGS) -c -o $@ -MMD -MF .deps/$*.d $<

# Have a place to store header dependencies automatically generated by compiler
.deps/timestamp:
	mkdir -p .deps
	touch .deps/timestamp

# Make use of said dependencies if available
-include .deps/*.d

=== debian/changelog ===
qr-code-generator (1.4.0-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS on arch any (Closes: #914148)
  * Add autopkgtest

 -- Yangfl <mmyangfl@gmail.com>  Sun, 18 Nov 2018 15:00:20 +0800

qr-code-generator (1.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #909158)

 -- Yangfl <mmyangfl@gmail.com>  Wed, 19 Sep 2018 12:46:28 +0800

=== debian/control ===
Source: qr-code-generator
Section: libs
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper (>=11~),
 dh-python,
 python3,
 python3-setuptools,
Standards-Version: 4.2.1
Homepage: https://github.com/nayuki/QR-Code-generator
Vcs-Git: https://salsa.debian.org/yangfl-guest/QR-Code-generator.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/QR-Code-generator

Package: libqrcodegen1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QR Code generator library in multiple languages - C version
 This project aims to be the best, clearest QR Code generator library in
 multiple languages. The primary goals are flexible options and absolute
 correctness. Secondary goals are compact implementation size and good
 documentation comments. Core features:
  * Available in 7 programming languages, all with nearly equal functionality:
    Java, JavaScript, TypeScript, Python, C++, C, Rust
  * Significantly shorter code but more documentation comments compared to
    competing libraries
  * Supports encoding all 40 versions (sizes) and all 4 error correction levels,
    as per the QR Code Model 2 standard
  * Output formats: Raw modules/pixels of the QR symbol (all languages), SVG XML
    string (all languages except C), BufferedImage raster bitmap (Java only),
    HTML5 canvas (JavaScript and TypeScript only)
  * Encodes numeric and special-alphanumeric text in less space than general
    text
  * Open source code under the permissive MIT License
 .
 This package contains the shared library in C.

Package: libqrcodegen-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libqrcodegen1 (= ${binary:Version}), ${misc:Depends}
Description: QR Code generator library in multiple languages - C development headers
 This project aims to be the best, clearest QR Code generator library in
 multiple languages. The primary goals are flexible options and absolute
 correctness. Secondary goals are compact implementation size and good
 documentation comments. Core features:
  * Available in 7 programming languages, all with nearly equal functionality:
    Java, JavaScript, TypeScript, Python, C++, C, Rust
  * Significantly shorter code but more documentation comments compared to
    competing libraries
  * Supports encoding all 40 versions (sizes) and all 4 error correction levels,
    as per the QR Code Model 2 standard
  * Output formats: Raw modules/pixels of the QR symbol (all languages), SVG XML
    string (all languages except C), BufferedImage raster bitmap (Java only),
    HTML5 canvas (JavaScript and TypeScript only)
  * Encodes numeric and special-alphanumeric text in less space than general
    text
  * Open source code under the permissive MIT License
 .
 This package contains the development files in C.

Package: libqrcodegencpp1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QR Code generator library in multiple languages - C++ version
 This project aims to be the best, clearest QR Code generator library in
 multiple languages. The primary goals are flexible options and absolute
 correctness. Secondary goals are compact implementation size and good
 documentation comments. Core features:
  * Available in 7 programming languages, all with nearly equal functionality:
    Java, JavaScript, TypeScript, Python, C++, C, Rust
  * Significantly shorter code but more documentation comments compared to
    competing libraries
  * Supports encoding all 40 versions (sizes) and all 4 error correction levels,
    as per the QR Code Model 2 standard
  * Output formats: Raw modules/pixels of the QR symbol (all languages), SVG XML
    string (all languages except C), BufferedImage raster bitmap (Java only),
    HTML5 canvas (JavaScript and TypeScript only)
  * Encodes numeric and special-alphanumeric text in less space than general
    text
  * Open source code under the permissive MIT License
 .
 This package contains the shared library in C++.

Package: libqrcodegencpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libqrcodegencpp1 (= ${binary:Version}), ${misc:Depends}
Description: QR Code generator library in multiple languages - C++ development headers
 This project aims to be the best, clearest QR Code generator library in
 multiple languages. The primary goals are flexible options and absolute
 correctness. Secondary goals are compact implementation size and good
 documentation comments. Core features:
  * Available in 7 programming languages, all with nearly equal functionality:
    Java, JavaScript, TypeScript, Python, C++, C, Rust
  * Significantly shorter code but more documentation comments compared to
    competing libraries
  * Supports encoding all 40 versions (sizes) and all 4 error correction levels,
    as per the QR Code Model 2 standard
  * Output formats: Raw modules/pixels of the QR symbol (all languages), SVG XML
    string (all languages except C), BufferedImage raster bitmap (Java only),
    HTML5 canvas (JavaScript and TypeScript only)
  * Encodes numeric and special-alphanumeric text in less space than general
    text
  * Open source code under the permissive MIT License
 .
 This package contains the development files in C++.

Package: python3-qrcodegen
Section: python
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${python3:Depends}
Description: QR Code generator library in multiple languages - Python3 version
 This project aims to be the best, clearest QR Code generator library in
 multiple languages. The primary goals are flexible options and absolute
 correctness. Secondary goals are compact implementation size and good
 documentation comments. Core features:
  * Available in 7 programming languages, all with nearly equal functionality:
    Java, JavaScript, TypeScript, Python, C++, C, Rust
  * Significantly shorter code but more documentation comments compared to
    competing libraries
  * Supports encoding all 40 versions (sizes) and all 4 error correction levels,
    as per the QR Code Model 2 standard
  * Output formats: Raw modules/pixels of the QR symbol (all languages), SVG XML
    string (all languages except C), BufferedImage raster bitmap (Java only),
    HTML5 canvas (JavaScript and TypeScript only)
  * Encodes numeric and special-alphanumeric text in less space than general
    text
  * Open source code under the permissive MIT License
 .
 This package contains the module in Python3.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_SYSTEM = distutils


%:
	dh $@ --with python3

%-arch:
	dh $@

%-indep:
	dh $@ --with python3

clean:
	dh $@

override_dh_auto_clean-indep:
	dh_auto_clean --buildsystem=pybuild --sourcedirectory=python/
	rm -rf python/qrcodegen.egg-info

override_dh_auto_build-indep:
	dh_auto_build --buildsystem=pybuild --sourcedirectory=python/

override_dh_auto_install-indep:
	dh_auto_install --buildsystem=pybuild --sourcedirectory=python/

override_dh_auto_clean-arch:
	dh_auto_clean --sourcedirectory=c/
	dh_auto_clean --sourcedirectory=cpp/

override_dh_clean-arch:
	dh_clean -a
	rm -rf ./c/libqrcodegen.so.1 ./cpp/libqrcodegencpp.so.1

override_dh_auto_build-arch:
	dh_auto_build --sourcedirectory=c/
	dh_auto_build --sourcedirectory=cpp/

override_dh_auto_test-arch:
	ln -sf libqrcodegen.so ./c/libqrcodegen.so.1
	ln -sf libqrcodegencpp.so ./cpp/libqrcodegencpp.so.1
	cd python && python3 qrcodegen-batch-test.py
	rm -rf ./c/libqrcodegen.so.1 ./cpp/libqrcodegencpp.so.1

override_dh_auto_install-arch:
	dh_auto_install --sourcedirectory=c/ -- QRCODEGEN_VERSION="$(DEB_VERSION_UPSTREAM)"
	dh_auto_install --sourcedirectory=cpp/ -- QRCODEGEN_VERSION="$(DEB_VERSION_UPSTREAM)"

## qr-code-generator 1.5.0

=== c/Makefile ===
# 
# Makefile for QR Code generator (C)
# 
# Copyright (c) Project Nayuki. (MIT License)
# https://www.nayuki.io/page/qr-code-generator-library
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# - The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
# - The Software is provided "as is", without warranty of any kind, express or
#   implied, including but not limited to the warranties of merchantability,
#   fitness for a particular purpose and noninfringement. In no event shall the
#   authors or copyright holders be liable for any claim, damages or other
#   liability, whether in an action of contract, tort or otherwise, arising from,
#   out of or in connection with the Software or the use or other dealings in the
#   Software.
# 


# ---- Configuration options ----

# External/implicit variables:
# - CC: The C compiler, such as gcc or clang.
# - CFLAGS: Any extra user-specified compiler flags (can be blank).

# Mandatory compiler flags
CFLAGS += -std=c99
# Diagnostics. Adding '-fsanitize=address' is helpful for most versions of Clang and newer versions of GCC.
CFLAGS += -Wall -fsanitize=undefined
# Optimization level
CFLAGS += -O1


# ---- Controlling make ----

# Clear default suffix rules
.SUFFIXES:

# Don't delete object files
.SECONDARY:

# Stuff concerning goals
.DEFAULT_GOAL = all
.PHONY: all clean


# ---- Targets to build ----

LIB = qrcodegen
LIBFILE = lib$(LIB).a
LIBOBJ = qrcodegen.o
MAINS = qrcodegen-demo qrcodegen-test qrcodegen-worker

# Build all binaries
all: $(LIBFILE) $(MAINS)

# Delete build output
clean:
	rm -f -- $(LIBOBJ) $(LIBFILE) $(MAINS:=.o) $(MAINS)
	rm -rf .deps

# Executable files
%: %.o $(LIBFILE)
	$(CC) $(CFLAGS) -o $@ $< -L . -l $(LIB)

# Special executable
qrcodegen-test: qrcodegen-test.c $(LIBOBJ:%.o=%.c)
	$(CC) $(CFLAGS) -DQRCODEGEN_TEST -o $@ $^

# The library
$(LIBFILE): $(LIBOBJ)
	$(AR) -crs $@ -- $^

# Object files
%.o: %.c .deps/timestamp
	$(CC) $(CFLAGS) -c -o $@ -MMD -MF .deps/$*.d $<

# Have a place to store header dependencies automatically generated by compiler
.deps/timestamp:
	mkdir -p .deps
	touch .deps/timestamp

# Make use of said dependencies if available
-include .deps/*.d

=== debian/changelog ===
qr-code-generator (1.5.0-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:55:13 +0100

qr-code-generator (1.5.0-2) unstable; urgency=medium

  * Fix symbols on 32-bit architectures

 -- Yangfl <mmyangfl@gmail.com>  Mon, 29 Jul 2019 11:09:12 +0800

qr-code-generator (1.5.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.4.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Sun, 21 Jul 2019 01:11:52 +0800

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper (>=11~),
+ debhelper-compat (= 12),
  dh-python,
  python3,
  python3-setuptools,
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Homepage: https://github.com/nayuki/QR-Code-generator
 Vcs-Git: https://salsa.debian.org/yangfl-guest/QR-Code-generator.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/QR-Code-generator

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,9 @@
 
 include /usr/share/dpkg/pkg-info.mk
 
-export PYBUILD_SYSTEM = distutils
+export VERSION := $(DEB_VERSION_UPSTREAM)
+export MULTIARCH := $(DEB_HOST_MULTIARCH)
+export PYBUILD_SYSTEM := distutils
 
 
 %:
@@ -53,5 +55,5 @@
 	rm -rf ./c/libqrcodegen.so.1 ./cpp/libqrcodegencpp.so.1
 
 override_dh_auto_install-arch:
-	dh_auto_install --sourcedirectory=c/ -- QRCODEGEN_VERSION="$(DEB_VERSION_UPSTREAM)"
-	dh_auto_install --sourcedirectory=cpp/ -- QRCODEGEN_VERSION="$(DEB_VERSION_UPSTREAM)"
+	dh_auto_install --sourcedirectory=c/
+	dh_auto_install --sourcedirectory=cpp/

## qr-code-generator 1.5.0-2build1+9.0trisquel2

=== c/Makefile ===
--- 
+++ 
@@ -28,13 +28,6 @@
 # - CC: The C compiler, such as gcc or clang.
 # - CFLAGS: Any extra user-specified compiler flags (can be blank).
 
-# Mandatory compiler flags
-CFLAGS += -std=c99
-# Diagnostics. Adding '-fsanitize=address' is helpful for most versions of Clang and newer versions of GCC.
-CFLAGS += -Wall -fsanitize=undefined
-# Optimization level
-CFLAGS += -O1
-
 
 # ---- Controlling make ----
 
@@ -52,17 +45,44 @@
 # ---- Targets to build ----
 
 LIB = qrcodegen
-LIBFILE = lib$(LIB).a
+LIBFILE = lib$(LIB).so
+ARFILE = lib$(LIB).a
+SO_NAME = $(LIBFILE).1
+REAL_NAME = $(LIBFILE).$(VERSION)
+HEADERS = qrcodegen.h
 LIBOBJ = qrcodegen.o
 MAINS = qrcodegen-demo qrcodegen-test qrcodegen-worker
 
+MULTIARCH ?= $(shell $(CC) --print-multiarch)
+
+INCLUDEDIR ?= $(DESTDIR)/usr/include/qrcodegen
+LIBDIR ?= $(DESTDIR)/usr/lib/$(MULTIARCH)
+
 # Build all binaries
-all: $(LIBFILE) $(MAINS)
+all: $(LIBFILE) $(ARFILE) $(MAINS)
 
 # Delete build output
 clean:
-	rm -f -- $(LIBOBJ) $(LIBFILE) $(MAINS:=.o) $(MAINS)
+	rm -f -- $(LIBOBJ) $(LIBFILE) $(ARFILE) $(MAINS:=.o) $(MAINS)
 	rm -rf .deps
+
+install-shared: $(LIBFILE)
+	install -d $(LIBDIR) || true
+	install -m 0644 $(LIBFILE) $(LIBDIR)/$(REAL_NAME)
+	rm -f $(LIBDIR)/$(SO_NAME)
+	ln -s $(REAL_NAME) $(LIBDIR)/$(SO_NAME)
+	rm -f $(LIBDIR)/$(LIBFILE)
+	ln -s $(SO_NAME) $(LIBDIR)/$(LIBFILE)
+
+install-static: $(ARFILE)
+	install -d $(LIBDIR) || true
+	install -m 0644 $(ARFILE) $(LIBDIR)/$(ARFILE)
+
+install-header: $(HEADERS)
+	install -d $(INCLUDEDIR) || true
+	install -m 0644 $(HEADERS) $(INCLUDEDIR)/
+
+install: install-shared install-static install-header
 
 # Executable files
 %: %.o $(LIBFILE)
@@ -73,12 +93,15 @@
 	$(CC) $(CFLAGS) -DQRCODEGEN_TEST -o $@ $^
 
 # The library
+$(ARFILE): $(LIBOBJ)
+	$(AR) -crs $@ -- $^
+
 $(LIBFILE): $(LIBOBJ)
-	$(AR) -crs $@ -- $^
+	$(CC) -shared -Wl,-soname,$(SO_NAME) $(LDFLAGS) -o $@ $^
 
 # Object files
 %.o: %.c .deps/timestamp
-	$(CC) $(CFLAGS) -c -o $@ -MMD -MF .deps/$*.d $<
+	$(CC) $(CFLAGS) -fPIC -c -o $@ -MMD -MF .deps/$*.d $<
 
 # Have a place to store header dependencies automatically generated by compiler
 .deps/timestamp:

=== cpp/Makefile ===
--- 
+++ 
@@ -28,13 +28,6 @@
 # - CXX: The C++ compiler, such as g++ or clang++.
 # - CXXFLAGS: Any extra user-specified compiler flags (can be blank).
 
-# Mandatory compiler flags
-CXXFLAGS += -std=c++11
-# Diagnostics. Adding '-fsanitize=address' is helpful for most versions of Clang and newer versions of GCC.
-CXXFLAGS += -Wall -fsanitize=undefined
-# Optimization level
-CXXFLAGS += -O1
-
 
 # ---- Controlling make ----
 
@@ -51,30 +44,60 @@
 
 # ---- Targets to build ----
 
-LIB = qrcodegen
-LIBFILE = lib$(LIB).a
+LIB = qrcodegencpp
+LIBFILE = lib$(LIB).so
+ARFILE = lib$(LIB).a
+SO_NAME = $(LIBFILE).1
+REAL_NAME = $(LIBFILE).$(VERSION)
+HEADERS = BitBuffer.hpp QrCode.hpp QrSegment.hpp
 LIBOBJ = BitBuffer.o QrCode.o QrSegment.o
 MAINS = QrCodeGeneratorDemo QrCodeGeneratorWorker
 
+MULTIARCH ?= $(shell $(CC) --print-multiarch)
+
+INCLUDEDIR ?= $(DESTDIR)/usr/include/qrcodegen
+LIBDIR ?= $(DESTDIR)/usr/lib/$(MULTIARCH)
+
 # Build all binaries
-all: $(LIBFILE) $(MAINS)
+all: $(LIBFILE) $(ARFILE) $(MAINS)
 
 # Delete build output
 clean:
-	rm -f -- $(LIBOBJ) $(LIBFILE) $(MAINS:=.o) $(MAINS)
+	rm -f -- $(LIBOBJ) $(LIBFILE) $(ARFILE) $(MAINS:=.o) $(MAINS)
 	rm -rf .deps
+
+install-shared: $(LIBFILE)
+	install -d $(LIBDIR) || true
+	install -m 0644 $(LIBFILE) $(LIBDIR)/$(REAL_NAME)
+	rm -f $(LIBDIR)/$(SO_NAME)
+	ln -s $(REAL_NAME) $(LIBDIR)/$(SO_NAME)
+	rm -f $(LIBDIR)/$(LIBFILE)
+	ln -s $(SO_NAME) $(LIBDIR)/$(LIBFILE)
+
+install-static: $(ARFILE)
+	install -d $(LIBDIR) || true
+	install -m 0644 $(ARFILE) $(LIBDIR)/$(ARFILE)
+
+install-header: $(HEADERS)
+	install -d $(INCLUDEDIR) || true
+	install -m 0644 $(HEADERS) $(INCLUDEDIR)/
+
+install: install-shared install-static install-header
 
 # Executable files
 %: %.o $(LIBFILE)
 	$(CXX) $(CXXFLAGS) -o $@ $< -L . -l $(LIB)
 
 # The library
+$(ARFILE): $(LIBOBJ)
+	$(AR) -crs $@ -- $^
+
 $(LIBFILE): $(LIBOBJ)
-	$(AR) -crs $@ -- $^
+	$(CXX) -shared -Wl,-soname,$(SO_NAME) $(LDFLAGS) -o $@ $^
 
 # Object files
 %.o: %.cpp .deps/timestamp
-	$(CXX) $(CXXFLAGS) -c -o $@ -MMD -MF .deps/$*.d $<
+	$(CXX) $(CXXFLAGS) -fPIC -c -o $@ -MMD -MF .deps/$*.d $<
 
 # Have a place to store header dependencies automatically generated by compiler
 .deps/timestamp:

=== debian/changelog ===
qr-code-generator (1.5.0-2build1+9.0trisquel2) etiona-backports; urgency=medium

  * Backported from Focal

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 30 Mar 2020 00:50:21 +0000

## qr-code-generator 1.6.0

=== c/Makefile ===
--- 
+++ 
@@ -28,6 +28,12 @@
 # - CC: The C compiler, such as gcc or clang.
 # - CFLAGS: Any extra user-specified compiler flags (can be blank).
 
+# Recommended compiler flags:
+CFLAGS += -std=c99 -O
+
+# Extra flags for diagnostics:
+# CFLAGS += -g -Wall -Wextra -Wpedantic -Wconversion -Wsign-conversion -fsanitize=undefined,address
+
 
 # ---- Controlling make ----
 
@@ -45,44 +51,17 @@
 # ---- Targets to build ----
 
 LIB = qrcodegen
-LIBFILE = lib$(LIB).so
-ARFILE = lib$(LIB).a
-SO_NAME = $(LIBFILE).1
-REAL_NAME = $(LIBFILE).$(VERSION)
-HEADERS = qrcodegen.h
+LIBFILE = lib$(LIB).a
 LIBOBJ = qrcodegen.o
 MAINS = qrcodegen-demo qrcodegen-test qrcodegen-worker
 
-MULTIARCH ?= $(shell $(CC) --print-multiarch)
-
-INCLUDEDIR ?= $(DESTDIR)/usr/include/qrcodegen
-LIBDIR ?= $(DESTDIR)/usr/lib/$(MULTIARCH)
-
 # Build all binaries
-all: $(LIBFILE) $(ARFILE) $(MAINS)
+all: $(LIBFILE) $(MAINS)
 
 # Delete build output
 clean:
-	rm -f -- $(LIBOBJ) $(LIBFILE) $(ARFILE) $(MAINS:=.o) $(MAINS)
+	rm -f -- $(LIBOBJ) $(LIBFILE) $(MAINS:=.o) $(MAINS)
 	rm -rf .deps
-
-install-shared: $(LIBFILE)
-	install -d $(LIBDIR) || true
-	install -m 0644 $(LIBFILE) $(LIBDIR)/$(REAL_NAME)
-	rm -f $(LIBDIR)/$(SO_NAME)
-	ln -s $(REAL_NAME) $(LIBDIR)/$(SO_NAME)
-	rm -f $(LIBDIR)/$(LIBFILE)
-	ln -s $(SO_NAME) $(LIBDIR)/$(LIBFILE)
-
-install-static: $(ARFILE)
-	install -d $(LIBDIR) || true
-	install -m 0644 $(ARFILE) $(LIBDIR)/$(ARFILE)
-
-install-header: $(HEADERS)
-	install -d $(INCLUDEDIR) || true
-	install -m 0644 $(HEADERS) $(INCLUDEDIR)/
-
-install: install-shared install-static install-header
 
 # Executable files
 %: %.o $(LIBFILE)
@@ -93,15 +72,12 @@
 	$(CC) $(CFLAGS) -DQRCODEGEN_TEST -o $@ $^
 
 # The library
-$(ARFILE): $(LIBOBJ)
+$(LIBFILE): $(LIBOBJ)
 	$(AR) -crs $@ -- $^
-
-$(LIBFILE): $(LIBOBJ)
-	$(CC) -shared -Wl,-soname,$(SO_NAME) $(LDFLAGS) -o $@ $^
 
 # Object files
 %.o: %.c .deps/timestamp
-	$(CC) $(CFLAGS) -fPIC -c -o $@ -MMD -MF .deps/$*.d $<
+	$(CC) $(CFLAGS) -c -o $@ -MMD -MF .deps/$*.d $<
 
 # Have a place to store header dependencies automatically generated by compiler
 .deps/timestamp:

=== cpp/Makefile ===
--- 
+++ 
@@ -28,6 +28,12 @@
 # - CXX: The C++ compiler, such as g++ or clang++.
 # - CXXFLAGS: Any extra user-specified compiler flags (can be blank).
 
+# Recommended compiler flags:
+CXXFLAGS += -std=c++11 -O
+
+# Extra flags for diagnostics:
+# CXXFLAGS += -g -Wall -Wextra -Wpedantic -Wconversion -Wsign-conversion -fsanitize=undefined,address
+
 
 # ---- Controlling make ----
 
@@ -44,60 +50,30 @@
 
 # ---- Targets to build ----
 
-LIB = qrcodegencpp
-LIBFILE = lib$(LIB).so
-ARFILE = lib$(LIB).a
-SO_NAME = $(LIBFILE).1
-REAL_NAME = $(LIBFILE).$(VERSION)
-HEADERS = BitBuffer.hpp QrCode.hpp QrSegment.hpp
-LIBOBJ = BitBuffer.o QrCode.o QrSegment.o
+LIB = qrcodegen
+LIBFILE = lib$(LIB).a
+LIBOBJ = QrCode.o
 MAINS = QrCodeGeneratorDemo QrCodeGeneratorWorker
 
-MULTIARCH ?= $(shell $(CC) --print-multiarch)
-
-INCLUDEDIR ?= $(DESTDIR)/usr/include/qrcodegen
-LIBDIR ?= $(DESTDIR)/usr/lib/$(MULTIARCH)
-
 # Build all binaries
-all: $(LIBFILE) $(ARFILE) $(MAINS)
+all: $(LIBFILE) $(MAINS)
 
 # Delete build output
 clean:
-	rm -f -- $(LIBOBJ) $(LIBFILE) $(ARFILE) $(MAINS:=.o) $(MAINS)
+	rm -f -- $(LIBOBJ) $(LIBFILE) $(MAINS:=.o) $(MAINS)
 	rm -rf .deps
-
-install-shared: $(LIBFILE)
-	install -d $(LIBDIR) || true
-	install -m 0644 $(LIBFILE) $(LIBDIR)/$(REAL_NAME)
-	rm -f $(LIBDIR)/$(SO_NAME)
-	ln -s $(REAL_NAME) $(LIBDIR)/$(SO_NAME)
-	rm -f $(LIBDIR)/$(LIBFILE)
-	ln -s $(SO_NAME) $(LIBDIR)/$(LIBFILE)
-
-install-static: $(ARFILE)
-	install -d $(LIBDIR) || true
-	install -m 0644 $(ARFILE) $(LIBDIR)/$(ARFILE)
-
-install-header: $(HEADERS)
-	install -d $(INCLUDEDIR) || true
-	install -m 0644 $(HEADERS) $(INCLUDEDIR)/
-
-install: install-shared install-static install-header
 
 # Executable files
 %: %.o $(LIBFILE)
 	$(CXX) $(CXXFLAGS) -o $@ $< -L . -l $(LIB)
 
 # The library
-$(ARFILE): $(LIBOBJ)
+$(LIBFILE): $(LIBOBJ)
 	$(AR) -crs $@ -- $^
-
-$(LIBFILE): $(LIBOBJ)
-	$(CXX) -shared -Wl,-soname,$(SO_NAME) $(LDFLAGS) -o $@ $^
 
 # Object files
 %.o: %.cpp .deps/timestamp
-	$(CXX) $(CXXFLAGS) -fPIC -c -o $@ -MMD -MF .deps/$*.d $<
+	$(CXX) $(CXXFLAGS) -c -o $@ -MMD -MF .deps/$*.d $<
 
 # Have a place to store header dependencies automatically generated by compiler
 .deps/timestamp:

=== debian/changelog ===
qr-code-generator (1.6.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.1
  * Bump debhelper compat to 13
  * Add upstream metadata

 -- Yangfl <mmyangfl@gmail.com>  Sun, 21 Feb 2021 23:21:08 +0800

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-python,
  python3,
  python3-setuptools,
-Standards-Version: 4.4.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.1
 Homepage: https://github.com/nayuki/QR-Code-generator
 Vcs-Git: https://salsa.debian.org/yangfl-guest/QR-Code-generator.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/QR-Code-generator

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_LDFLAGS_MAINT_APPEND =
 
 include /usr/share/dpkg/pkg-info.mk

## qr-code-generator 1.7.0

=== debian/changelog ===
qr-code-generator (1.7.0-2) unstable; urgency=medium

  * Fix ABI interface

 -- Yangfl <mmyangfl@gmail.com>  Mon, 24 Jan 2022 22:44:43 +0800

qr-code-generator (1.7.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0

 -- Yangfl <mmyangfl@gmail.com>  Sun, 02 Jan 2022 18:52:31 +0800

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
  debhelper-compat (= 13),
+Build-Depends-Indep:
  dh-python,
  python3,
  python3-setuptools,
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/nayuki/QR-Code-generator
 Vcs-Git: https://salsa.debian.org/yangfl-guest/QR-Code-generator.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/QR-Code-generator

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 	dh $@
 
 override_dh_auto_clean-indep:
-	dh_auto_clean --buildsystem=pybuild --sourcedirectory=python/
+	-dh_auto_clean --buildsystem=pybuild --sourcedirectory=python/
 	rm -rf python/qrcodegen.egg-info
 
 override_dh_auto_build-indep:
@@ -40,19 +40,12 @@
 	dh_auto_clean --sourcedirectory=c/
 	dh_auto_clean --sourcedirectory=cpp/
 
-override_dh_clean-arch:
-	dh_clean -a
-	rm -rf ./c/libqrcodegen.so.1 ./cpp/libqrcodegencpp.so.1
-
 override_dh_auto_build-arch:
 	dh_auto_build --sourcedirectory=c/
 	dh_auto_build --sourcedirectory=cpp/
 
 override_dh_auto_test-arch:
-	ln -sf libqrcodegen.so ./c/libqrcodegen.so.1
-	ln -sf libqrcodegencpp.so ./cpp/libqrcodegencpp.so.1
-	cd python && python3 qrcodegen-batch-test.py
-	rm -rf ./c/libqrcodegen.so.1 ./cpp/libqrcodegencpp.so.1
+	./c/qrcodegen-test
 
 override_dh_auto_install-arch:
 	dh_auto_install --sourcedirectory=c/

## qr-code-generator 1.8.0

=== debian/changelog ===
qr-code-generator (1.8.0-1.2build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:56:55 +0200

qr-code-generator (1.8.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control:
    + Fix typo.
    + Do not list ${maven:CompileDepends} from libqrcodegen-java
      runtime dependencies per bug report request. (Closes: #1015192)

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Sep 2023 20:46:07 -0400

qr-code-generator (1.8.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload.

 -- Boyuan Yang <byang@debian.org>  Mon, 16 May 2022 20:25:05 -0400

qr-code-generator (1.8.0-1) unstable; urgency=medium

  * New upstream release
  * Package java library (Closes: #1010618)
  * Bump Standards-Version to 4.6.1

 -- Yangfl <mmyangfl@gmail.com>  Mon, 16 May 2022 23:34:58 +0800

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,19 @@
 Source: qr-code-generator
 Section: libs
 Priority: optional
-Maintainer: Yangfl <mmyangfl@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Indep:
  dh-python,
  python3,
+ libmaven-compiler-plugin-java,
  python3-setuptools,
+ default-jdk,
+ maven-debian-helper,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/nayuki/QR-Code-generator
 Vcs-Git: https://salsa.debian.org/yangfl-guest/QR-Code-generator.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/QR-Code-generator
@@ -138,3 +142,28 @@
   * Open source code under the permissive MIT License
  .
  This package contains the module in Python3.
+
+Package: libqrcodegen-java
+Section: java
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}, ${maven:Depends}
+Description: QR Code generator library in multiple languages - Java version
+ This project aims to be the best, clearest QR Code generator library in
+ multiple languages. The primary goals are flexible options and absolute
+ correctness. Secondary goals are compact implementation size and good
+ documentation comments. Core features:
+  * Available in 7 programming languages, all with nearly equal functionality:
+    Java, JavaScript, TypeScript, Python, C++, C, Rust
+  * Significantly shorter code but more documentation comments compared to
+    competing libraries
+  * Supports encoding all 40 versions (sizes) and all 4 error correction levels,
+    as per the QR Code Model 2 standard
+  * Output formats: Raw modules/pixels of the QR symbol (all languages), SVG XML
+    string (all languages except C), BufferedImage raster bitmap (Java only),
+    HTML5 canvas (JavaScript and TypeScript only)
+  * Encodes numeric and special-alphanumeric text in less space than general
+    text
+  * Open source code under the permissive MIT License
+ .
+ This package contains the library for Java.

=== debian/rules ===
--- 
+++ 
@@ -28,12 +28,27 @@
 
 override_dh_auto_clean-indep:
 	-dh_auto_clean --buildsystem=pybuild --sourcedirectory=python/
+	# mh_(un)patchpoms does not obey --sourcedirectory=java/
+	-mh_patchpoms -plibqrcodegen-java
+	-dh_auto_clean --buildsystem=maven --sourcedirectory=java/ -plibqrcodegen-java
+	-mh_unpatchpoms -plibqrcodegen-java
 	rm -rf python/qrcodegen.egg-info
+
+execute_before_dh_auto_configure-indep:
+	dh_auto_configure --buildsystem=maven -plibqrcodegen-java
 
 override_dh_auto_build-indep:
 	dh_auto_build --buildsystem=pybuild --sourcedirectory=python/
+	dh_auto_build --buildsystem=maven --sourcedirectory=java/
 
 override_dh_auto_install-indep:
+	# mv, sed, rm: work around buildsystem=maven calling mh_resolve_dependencies in java/
+	mv java/pom.xml.save java/pom.xml.backup
+	dh_auto_install -plibqrcodegen-java --buildsystem=maven --sourcedirectory=java/
+	mv java/pom.xml.backup java/pom.xml.save
+	mh_unpatchpoms -plibqrcodegen-java
+	sed -i 's/maven\./maven:/' debian/libqrcodegen-java.substvars
+	rm -r java/.debianVersion java/debian/
 	dh_auto_install --buildsystem=pybuild --sourcedirectory=python/
 
 override_dh_auto_clean-arch:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%qr-code-generator-$1.tar.gz%" \
   https://github.com/nayuki/QR-Code-generator/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
